﻿// Add to web template
// <script type="text/javascript" src="/global.js"></script>

var MBIE_Global = MBIE_Global || {};

MBIE_Global.showField = function (fieldName) {
    $("#" + fieldName).closest("td").show();
}

MBIE_Global.hideField = function (fieldName) {
    $("#" + fieldName).closest("td").hide();
}

MBIE_Global.disableField = function (fieldName) {
    $("#" + fieldName).prop("disabled", true).prop("readonly", true).parent().find(".input-group-btn").hide();
}

MBIE_Global.enableField = function (fieldName) {
    $("#" + fieldName).prop("disabled", false).prop("readonly", false).parent().find(".input-group-btn").show();
}

MBIE_Global.makeRequired = function (fieldName) {
    if ($("#" + fieldName) != undefined && !$("#" + fieldName).prop('required')) {
        $("#" + fieldName).prop('required', true);
        $("#" + fieldName).closest(".control").prev().addClass("required");

        // Create new validator
        var requiredvalidator = document.createElement('span');
        requiredvalidator.style.display = "none";
        requiredvalidator.id = fieldName + "Validator";
        requiredvalidator.controltovalidate = fieldName;
        requiredvalidator.errormessage = "<a href='#" + fieldName + "_label'>" + $("#" + fieldName + "_label").html() + " is a required field.</a>";
        requiredvalidator.initialvalue = "";
        requiredvalidator.evaluationfunction = function () {
            var value = $("#" + fieldName).val();
            if (value == null || value == "") {
                return false;
            } else {
                return true;
            }
        };

        // Add the new validator to the page validators array:
        Page_Validators.push(requiredvalidator);
    }
}

MBIE_Global.makeNotRequired = function (fieldName) {
    if ($("#" + fieldName) != undefined) {
        $("#" + fieldName).closest(".control").prev().removeClass("required");
        $("#" + fieldName).prop('required', false);

        for (i = 0; i < Page_Validators.length; i++) {
            if (Page_Validators[i].id == "RequiredFieldValidator" + fieldName || Page_Validators[i].id == fieldName + "Validator") {
                Page_Validators.splice(i, 1);
            }
        }
    }
}

MBIE_Global.addFutureValidationForDate = function (fieldName) {
    $("#" + fieldName).next().data("DateTimePicker").maxDate(moment().startOf('day'));

    // Create new validator
    var requiredvalidator = document.createElement('span');
    requiredvalidator.style.display = "none";
    requiredvalidator.id = fieldName + "FutureValidator";
    requiredvalidator.controltovalidate = fieldName;
    requiredvalidator.errormessage = "<a href='#" + fieldName + "_label'>" + $("#" + fieldName + "_label").html() + " cannot be in the future.</a>";
    requiredvalidator.initialvalue = "";
    requiredvalidator.evaluationfunction = function () {
        var value = $("#" + fieldName).val();
        if (value == null || value == "") {
            return true;
        }
        else {
            return moment(value) <= moment().startOf('day');
        }
    };

    // Add the new validator to the page validators array:
    Page_Validators.push(requiredvalidator);
}

MBIE_Global.addPastValidationForDate = function (fieldName) {
    $("#" + fieldName).next().data("DateTimePicker").minDate(moment().startOf('day'));

    // Create new validator
    var requiredvalidator = document.createElement('span');
    requiredvalidator.style.display = "none";
    requiredvalidator.id = fieldName + "PastValidator";
    requiredvalidator.controltovalidate = fieldName;
    requiredvalidator.errormessage = "<a href='#" + fieldName + "_label'>" + $("#" + fieldName + "_label").html() + " cannot be in the past.</a>";
    requiredvalidator.initialvalue = "";
    requiredvalidator.evaluationfunction = function () {
        var value = $("#" + fieldName).val();
        if (value == null || value == "") {
            return true;
        }
        else {
            return moment(value) >= moment().startOf('day');
        }
    };

    // Add the new validator to the page validators array:
    Page_Validators.push(requiredvalidator);
}

// Add this logic so that user can click anywhere on the lookup field to open the dialog window instead of select the lookup icon only
MBIE_Global.popUpLookUpOnFocus = function (fieldNames) {
    for (var i = 0; i < fieldNames.length; i++) {
        IndividualModalFocus(fieldNames[i]);
    }
}

MBIE_Global.addPlaceHolderText = function (fieldName, text) {
    document.getElementById(fieldName).placeholder = text;
}

MBIE_Global.setLookUpValue = function (fieldName, fieldId, fieldScheme) {
    $("#" + fieldName).val(fieldId);
    $("#" + fieldName +"_entityname").val(fieldScheme);
}

MBIE_Global.getPageHeaderText = function (reportingPeriod) {
    var pageHeaderText;

    if (_schemeName != "") {
        var pageHeaderText = _reportingEntityName + " - " + _schemeName + " - Climate Statement Lodgement - " + reportingPeriod;
    }
    else {
        var pageHeaderText = _reportingEntityName + " - Climate Statement Lodgement - " + reportingPeriod;
    }

    return pageHeaderText;
}

function IndividualModalFocus(fieldName) {
    $("input#" + fieldName + "_name").on("click", function () {
        $("div.input-group:has(input#" + fieldName + ") button.launchentitylookup").trigger("click");
        setTimeout(function () {
            var searchInput = $("div#" + fieldName + "_lookupmodal div.entitylist-search input[placeholder='Search']");
            searchInput.focus();

            searchInput.keyup(function () {
                $("div#" + fieldName + "_lookupmodal div.entitylist-search div.input-group-btn button").trigger("click");
            });
        }, 500);
    });
}